Subject: [PATCH v4] ARM: sched_clock: allow sched_clock to be selected at runtime

From: [email-masked] (Tony Lindgren)
Date: Mon, 12 Dec 2011 16:46:56 -0800

* Marc Zyngier <[email-masked]> [111212 08:33]:
> On 12/12/11 03:57, Rob Herring wrote:
> > On 12/09/2011 09:33 AM, Marc Zyngier wrote:
> >> sched_clock() is yet another blocker on the road to the single
> >> image. This patch implements an idea by Russell King:
> >>
> >> http://www.spinics.net/lists/linux-omap/msg49561.html
> >>
> >> Instead of asking the platform to implement both sched_clock()
> >> itself and the rollover callback, simply register a read()
> >> function, and let the ARM code care about sched_clock() itself,
> >> the conversion to ns and the rollover. sched_clock() uses
> >> this read() function as an indirection to the platform code.
> >> If the platform doesn't provide a read(), the code falls back
> >> to the jiffy counter (just like the default sched_clock).
> >>
> >> This allow some simplifications and possibly some footprint gain
> >> when multiple platforms are compiled in. Among the drawbacks,
> >> the removal of the *_fixed_sched_clock optimization which could
> >> negatively impact some platforms (sa1100, tegra, versatile
> >> and omap).
> >>
> >> Tested on 11MPCore, OMAP4 and Tegra.
> >>
> >> Cc: Imre Kaloz <[email-masked]>
> >> Cc: Krzysztof Halasa <[email-masked]>
> >> Cc: Tony Lindgren <[email-masked]>
> >> Cc: Eric Miao <[email-masked]>
> >> Cc: Colin Cross <[email-masked]>
> >> Cc: Erik Gilling <[email-masked]>
> >> Cc: Olof Johansson <[email-masked]>
> >> Cc: Linus Walleij <[email-masked]>
> >> Cc: Sascha Hauer <[email-masked]>
> >> Cc: Alessandro Rubini <[email-masked]>
> >> Cc: STEricsson <[email-masked]>
> >> Cc: Lennert Buytenhek <[email-masked]>
> >> Cc: Nicolas Pitre <[email-masked]>
> >> Cc: Ben Dooks <[email-masked]>
> >> Cc: Kukjin Kim <[email-masked]>
> >> Cc: Jamie Iles <[email-masked]>
> >> Tested-by: Jamie Iles <[email-masked]>
> >> Acked-by: Linus Walleij <[email-masked]>
> >> Signed-off-by: Marc Zyngier <[email-masked]>
> >> ---
> >> I'm reposting this patch with the hope that it (or Russell's
> >> alternative patch http://patchwork.ozlabs.org/patch/115961/)
> >> will get merged in 3.3. It doesn't look intrusive enough to be
> >> left on the side of the road for yet another cycle...
> >>
> > 
> > Please! I've been holding off on (re)doing and submitting sched_clock
> > support for highbank until this goes in.
> 
> Queued as patch 7205/1.
> 
> 	M.

Great, seems to boot fine on all omaps I tried, will go ack it
in the patch system.

Tony